<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="mod_negotiation － Apache 2.2 中文手册 [金步国作品集]">
<title>mod_negotiation － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body><div id="page-header">
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="./index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a> &gt; <a href="./index.html">模块</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2006年10月20日</div>
<div id="page-content"><div id="preamble"><h1>Apache模块 mod_negotiation</h1>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="module">
<tr><th><a href="module-dict.html#Description">说明</a></th><td>提供<a href="../content-negotiation.html">内容协商</a>支持</td></tr>
<tr><th><a href="module-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">模块名</a></th><td>negotiation_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">源文件</a></th><td>mod_negotiation.c</td></tr>
</table>
<h3>概述</h3>

    <p>内容协商，更准确的说应该是"内容选择"，是从几个有效文档中选择一个最匹配客户端要求的文档的过程。内容协商有两种实现方法。</p>

    <ul>
      <li>使用类型表(一个包含<code>type-map</code>处理器信息的文件)明确地列出各变种的文件名。</li>

      <li>使用"MultiViews"搜索(由<code class="directive"><a href="../mod/core.html#options">Options</a></code>指令中的<code>MultiViews</code>选项激活)，即服务器执行一个隐含的文件名模式匹配，并在结果中选择。</li>
    </ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="typemaps" id="typemaps">类型表</a></h2>
    <p>类型表的格式有点类似于RFC822邮件头的格式。它包含以空行分格的文档描述，以井号(#)打头的行被当作是注释。一个文档描述包含几个头记录，以空格开始的行将被认为是前一行的延续，这样文档描述记录就可以包含多行。在处理处理多行记录时，行与行被连接起来，打头的空格会被删除。一个头记录包含一个关键字名，并且总是在结尾的地方用一个冒号将它自己和紧跟其后的值分隔开。在头名字与它的值之间以及取值的各个标记之间可以插入空格。头可以是：</p>

    <dl>
      <dt><code>Content-Encoding:</code></dt>
      <dd>文件的编码方式。Apache只支持用<code class="directive"><a href="../mod/mod_mime.html#addencoding">AddEncoding</a></code>指令定义的编码方式。它一般包含compress压缩文件的<code>x-compress</code>编码和gzip文件的<code>x-gzip</code>编码。在编码对照过程中，"<code>x-</code>"前缀会被忽略。</dd>

      <dt><code>Content-Language:</code></dt>
      <dd>按互联网标准语言标签(<a href="http://www.ietf.org/rfc/rfc1766.txt">RFC 1766</a>)定义的变体语言。举例来说<code>en</code>表示英语。如果变体包含一种以上的语言，用逗号来分隔。</dd>

      <dt><code>Content-Length:</code></dt>
      <dd>以字节为单位的文件长度。如果这个头不存在，则使用文件的实际长度。</dd>

      <dt><code>Content-Type:</code></dt>

      <dd>带可选参数的文档<a class="glossarylink" href="../glossary.html#mime-type" title="see glossary">MIME类型</a>。参数与MIME类型之间以及参数之间都用分号分隔，参数使用类似"<code>name=value</code>"这样的语法。参数包括：
        <dl>
          <dt><code>level</code></dt>
          <dd>一个指明媒体类型版本的整数。对<code>text/html</code>来讲，默认值是"2"，其它的默认值为"0"。</dd>

          <dt><code>qs</code></dt>
          <dd>一个取值在0.0到1.0之间的浮点数，它表示在不考虑客户端性能的情况下，一个变体相对于其它变体的"品质"。比如在表现一张照片时，jpeg文件通常比字符构图有较高的还原品质；而如果要表现的本来就是一个字符构图，那么当然Ascii文件会比jpeg文件有较高的还原品质。因此，所有的<code>qs</code>取值都是特定于某个资源的。</dd>
        </dl>

        <div class="example"><h3>示例</h3><p><code>
          Content-Type: image/jpeg; qs=0.8
        </code></p></div>
      </dd>

      <dt><code>URI:</code></dt>
      <dd>文件的URI包含了媒体类型、编码方式等变量的信息，这些被解释为与映射文件相关的URL ，它们必须在<strong>同一个</strong>服务器上。如果它们被直接调用的话，它们所涉及的文件必须对用户是可以访问的。</dd>

      <dt><code>Body:</code></dt>
      <dd>这是2.0新增的功能，使用Body头，资源的实际内容可以直接包含在类型表里。这个头必须包含一个指明分隔符的字符串。这样在类型表文件中，接下来直到分隔字符串之前的所有内容，会被当作是资源实体。
      <div class="example"><h3>示例：</h3><p><code>
        Body:----xyz----<br />
        &lt;html&gt;<br />
        &lt;body&gt;<br />
        &lt;p&gt;Content of the page.&lt;/p&gt;<br />
        &lt;/body&gt;<br />
        &lt;/html&gt;<br />
        ----xyz----
      </code></p></div>
      </dd>
    </dl>
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="multiviews" id="multiviews">MultiViews</a></h2>
    <p>MultiViews查询是由<code class="directive"><a href="../mod/core.html#options">Options</a></code>指令的<code>MultiViews</code>选项激活的。如果服务器接收了一个对<code>/some/dir/foo</code>的请求，而<code>/some/dir/foo</code>并<em>不</em>存在，则服务器会查找这个目录下所有的 <code>foo.*</code> 文件，并有效地伪造一个说明这些 <code>foo.*</code> 文件的类型表，假定客户可能请求的一个，把他们指定为这个类型的媒体类型及内容编码。最终选择其中最符合客户请求的文档，返回给客户。</p>

    <p><code class="directive"><a href="../mod/mod_mime.html#multiviewsmatch">MultiViewsMatch</a></code>指令指示Apache在选择文件时是否考虑不包含内容协商元信息的文件。</p>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="CacheNegotiatedDocs" id="CacheNegotiatedDocs">CacheNegotiatedDocs</a> <a name="cachenegotiateddocs" id="cachenegotiateddocs">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>允许经过内容协商的文档被代理服务器缓存</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>CacheNegotiatedDocs On|Off</code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>CacheNegotiatedDocs Off</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_negotiation</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>从2.0版本起，语法有了变化</td></tr>
</table>
    <p>如果设置为"On"，则允许内容协商文档被代理服务器缓存。这可能意味着在代理服务器后面的客户端得到的文档并不是最符合他们情况的版本，但它能够使缓存更有效。</p>

    <p>本指令只对HTTP/1.0浏览器的请求有效。HTTP/1.1在对内容协商文档进行缓冲方面提供了更好的控制，本指令对于HTTP/1.1的应答没有效果。</p>

    <p>在2.0版本以前，<code class="directive">CacheNegotiatedDocs</code>指令不带任何参数；它会自己在目录存在的情况下开启。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="ForceLanguagePriority" id="ForceLanguagePriority">ForceLanguagePriority</a> <a name="forcelanguagepriority" id="forcelanguagepriority">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>指定无法匹配单个文档的情况下所采取的动作</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>ForceLanguagePriority None|Prefer|Fallback [Prefer|Fallback]</code></td></tr>
<tr><th><a href="directive-dict.html#Default">默认值</a></th><td><code>ForceLanguagePriority Prefer</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host, directory, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">覆盖项</a></th><td>FileInfo</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_negotiation</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>仅在 Apache 2.0.30 及以后的版本中可用</td></tr>
</table>
    <p><code class="directive">ForceLanguagePriority</code>指令使用<code class="directive"><a href="#languagepriority">LanguagePriority</a></code>指令的设置，在服务器无法返回单个匹配文档的情况下，指定完成协商过程的方法。</p>

    <p><code>ForceLanguagePriority Prefer</code> 在有几个等价选择的情况下，使用<code>LanguagePriority</code>的设定以提供一个有效的结果，而不是返回HTTP结果"300"(多重选择)。如果给出了下述指令，并且用户的<code>Accept-Language</code>头为<code>en</code>和<code>de</code>赋予了相同的品质系数"<code>.500</code>"(相同的品质系数是允许的)，那么第一个匹配的变体：<code>en</code>将被返回。</p>

    <div class="example"><p><code>
      LanguagePriority en fr de<br />
      ForceLanguagePriority Prefer
    </code></p></div>

    <p><code>ForceLanguagePriority Fallback</code> 使用<code class="directive"><a href="#languagepriority">LanguagePriority</a></code>指令在无法找到合适结果的情况下，指定一个有效的结果，而不是返回HTTP结果"406"(不可接受)。如果给出了下述指令，并且用户的<code>Accept-Language</code>头只允许<code>es</code>的返回结果，在这个变体没有找到的情况下，下述<code class="directive"><a href="#languagepriority">LanguagePriority</a></code>指令列表的第一个变体将被返回。</p>

    <div class="example"><p><code>
      LanguagePriority en fr de<br />
      ForceLanguagePriority Fallback
    </code></p></div>

    <p><code>Prefer</code>和<code>Fallback</code>两个选项可以同时指定，这样在有一个以上有效变体的情况下，返回<code class="directive"><a href="#languagepriority">LanguagePriority</a></code>指令列表中第一个匹配的变体文档，而在没有变体能够匹配客户可接受的语言的情况下，返回第一个可用的变体文档。</p>

<h3>参见</h3>
<ul>
<li><code class="directive"><a href="../mod/mod_mime.html#addlanguage">AddLanguage</a></code></li>
</ul>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="LanguagePriority" id="LanguagePriority">LanguagePriority</a> <a name="languagepriority" id="languagepriority">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>在客户端没有指示语言偏好的情况下，语言变体的优先级列表</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>LanguagePriority <var>MIME-lang</var> [<var>MIME-lang</var>] ...</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host, directory, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">覆盖项</a></th><td>FileInfo</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>基本(B)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_negotiation</td></tr>
</table>
    <p>在处理MultiViews请求时，<code class="directive">LanguagePriority</code>指令在客户没有指示语言偏爱的情况下，设定语言变体的优先级列表。这个<var>MIME-lang</var>列表是按优先级降序排列的。</p>

    <div class="example"><h3>示例：</h3><p><code>
      LanguagePriority en fr de
    </code></p></div>

    <p>表示对于<code>foo.html</code>请求，如果<code>foo.html.fr</code>和<code>foo.html.de</code>同时存在，并且浏览器没有表明对语言的偏爱，那么<code>foo.html.fr</code>将被返回。</p>

    <p>注意，本指令只在根据其它信息无法决定最好的语言或者<code class="directive"><a href="#forcelanguagepriority">ForceLanguagePriority</a></code>指令不是<code>None</code>时才有效。对正确实现的HTTP/1.1请求，本指令没有任何作用。</p>

<h3>参见</h3>
<ul>
<li><code class="directive"><a href="../mod/mod_mime.html#addlanguage">AddLanguage</a></code></li>
</ul>
</div>
</div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
